NDSummary.OnToolTipsLoaded("File:API_Specifications/Client-Side_APIs/webappos.js",{276:"<div class=\"NDToolTip TFile LJavaScript\"><div class=\"TTSummary\">Each webAppOS app should include the webappos.js script, which ensures the existence of the window.webappos JavaScript object for calling webAppOS-related functions and services.</div></div>",277:"<div class=\"NDToolTip TProperty LJavaScript\"><div class=\"TTSummary\">The webappos object contains useful webAppOS-specific functions and fields.&nbsp; The object is shared between all iframes loaded from the same domain; some functions and fields, however, are iframe-specific.</div></div>",278:"<div class=\"NDToolTip TProperty LJavaScript\"><div class=\"TTSummary\">A one-argument function for managing web calls and special submitter links in web memory.&nbsp; If specified, the interrupt function is called each time before a web call is being invoked or a submitter link created.&nbsp; The argument can be one of the following:</div></div>",280:"<div class=\"NDToolTip TFunction LJavaScript\"><div id=\"NDPrototype280\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\">window.webappos.webcall_and_wait = <span class=\"SHKeyword\">function</span> (</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PName first last\">action,</td></tr><tr><td class=\"PName first last\">arg</td></tr></table></td><td class=\"PAfterParameters\">)</td></tr></table></div><div class=\"TTSummary\">Executes the given web call synchronously via the webAppOS webcalls service.</div></div>",281:"<div class=\"NDToolTip TFunction LJavaScript\"><div id=\"NDPrototype281\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\">window.webappos.webcall = async <span class=\"SHKeyword\">function</span> (</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PName first last\">actionName,</td></tr><tr><td class=\"PName first last\">arg</td></tr></table></td><td class=\"PAfterParameters\">)</td></tr></table></div><div class=\"TTSummary\">Executes the given web call asynchronously via the webAppOS webcalls service.&nbsp; Client-side webcalls are executed right away.</div></div>",282:"<div class=\"NDToolTip TFunction LJavaScript\"><div id=\"NDPrototype282\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\">window.webappos.get_client_webcall_window = async <span class=\"SHKeyword\">function</span>(</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PName first last\">actionName,</td></tr><tr><td class=\"PName first last\">arg</td></tr></table></td><td class=\"PAfterParameters\">)</td></tr></table></div><div class=\"TTSummary\">Returns the window, where the given clinet-side webcall should be executed.&nbsp; This function can be redefined (e.g., by EnvironmentEngine) to support internal iframes.&nbsp; The function is asynchronous since we may need to wait until the iframe/window is loaded.</div></div>",284:"<div class=\"NDToolTip TVariable LJavaScript\"><div id=\"NDPrototype284\" class=\"NDPrototype NoParameterForm\">window.webappos.desktop</div><div class=\"TTSummary\">Provides access to Desktop API. Either passes Desktop API calls to the parent window (if the parent provides Desktop API), or implements by its own.&nbsp; In the latter case, the default implementation is tailored for single-page webAppOS applications that do not use the desktop. However, webAppOS desktop applications (like the shipped default Desktop app) should redefine functions from Desktop API marked as [DESKTOP-SPECIFIC].</div></div>",285:"<div class=\"NDToolTip TVariable LJavaScript\"><div id=\"NDPrototype285\" class=\"NDPrototype NoParameterForm\">webappos.desktop.get_width</div><div class=\"TTSummary\">Provides access to Desktop API. Either passes Desktop API calls to the parent window (if the parent provides Desktop API), or implements by its own.&nbsp; In the latter case, the default implementation is tailored for single-page webAppOS applications that do not use the desktop. However, webAppOS desktop applications (like the shipped default Desktop app) should redefine functions from Desktop API marked as [DESKTOP-SPECIFIC].</div></div>",286:"<div class=\"NDToolTip TFunction LJavaScript\"><div id=\"NDPrototype286\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\">webappos.desktop.launch_in_desktop = <span class=\"SHKeyword\">function</span> (</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PName first last\">url,</td></tr><tr><td class=\"PName first last\">app_url_name</td></tr></table></td><td class=\"PAfterParameters\">)</td></tr></table></div><div class=\"TTSummary\">Asks the desktop to open the given URL as desktop window associated with the given app.</div></div>",287:"<div class=\"NDToolTip TFunction LJavaScript\"><div id=\"NDPrototype287\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\">webappos.desktop.open_path = <span class=\"SHKeyword\">function</span> (</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PName first last\">path,</td></tr><tr><td class=\"PName first last\">full_screen</td></tr></table></td><td class=\"PAfterParameters\">)</td></tr></table></div><div class=\"TTSummary\">Opens the given path by launching the corresponding webAppOS app and passing the path as argument.&nbsp; For webAppOS project_ids launches the corresponding associated app.&nbsp; For directories and unidentified apps, launches FileBrowser app.</div></div>",288:"<div class=\"NDToolTip TFunction LJavaScript\"><div id=\"NDPrototype288\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\">webappos.desktop.launch_app = <span class=\"SHKeyword\">function</span> (</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PName first last\">app_url_name,</td></tr><tr><td class=\"PName first last\">full_screen</td></tr></table></td><td class=\"PAfterParameters\">)</td></tr></table></div><div class=\"TTSummary\">Launches the given webAppOS app.</div></div>",289:"<div class=\"NDToolTip TFunction LJavaScript\"><div id=\"NDPrototype289\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\">webappos.desktop.set_shared_value = <span class=\"SHKeyword\">function</span> (</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PName first last\">key,</td></tr><tr><td class=\"PName first last\">value</td></tr></table></td><td class=\"PAfterParameters\">)</td></tr></table></div><div class=\"TTSummary\">Sets some desktop-wide property that can be used for inter-app communication.</div></div>",290:"<div class=\"NDToolTip TFunction LJavaScript\"><div id=\"NDPrototype290\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\">webappos.desktop.get_shared_value = async <span class=\"SHKeyword\">function</span> (</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PName first last\">key</td></tr></table></td><td class=\"PAfterParameters\">)</td></tr></table></div><div class=\"TTSummary\">Returns the desired desktop-wide property.</div></div>",291:"<div class=\"NDToolTip TFunction LJavaScript\"><div id=\"NDPrototype291\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\">window.webappos.desktop.show_dialog = <span class=\"SHKeyword\">function</span> (</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PName first last\">title,</td></tr><tr><td class=\"PName first last\">content,</td></tr><tr><td class=\"PName first last\">fOnClose,</td></tr><tr><td class=\"PName first last\">w,</td></tr><tr><td class=\"PName first last\">h</td></tr></table></td><td class=\"PAfterParameters\">)</td></tr></table></div><div class=\"TTSummary\">Asks the desktop to show a dialog window within a desktop.</div></div>",292:"<div class=\"NDToolTip TFunction LJavaScript\"><div id=\"NDPrototype292\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\">window.webappos.desktop.close_dialog = <span class=\"SHKeyword\">function</span> (</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PName first last\">handle</td></tr></table></td><td class=\"PAfterParameters\">)</td></tr></table></div><div class=\"TTSummary\">Asks the desktop to close the previously open dialog window.</div></div>",293:"<div class=\"NDToolTip TFunction LJavaScript\"><div id=\"NDPrototype293\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\">webappos.desktop.browse_for_file = async <span class=\"SHKeyword\">function</span> (</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PName first last\">dialog_type,</td></tr><tr><td class=\"PName first last\">files_filter</td></tr></table></td><td class=\"PAfterParameters\">)</td></tr></table></div><div class=\"TTSummary\">Shows the browse for file dialog. Relies on webappos.desktop.show_dialog, webappos.desktop.close_dialog, webappos.desktop.set_shared_value, and webappos.desktop.get_shared_value.</div></div>",294:"<div class=\"NDToolTip TFunction LJavaScript\"><div id=\"NDPrototype294\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\">webappos.desktop.show_launcher = <span class=\"SHKeyword\">function</span> (</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PName first last\">around_id</td></tr></table></td><td class=\"PAfterParameters\">)</td></tr></table></div><div class=\"TTSummary\">Shows (or hides, if shown) the launcher menu containing the list of available apps.</div></div>",295:"<div class=\"NDToolTip TFunction LJavaScript\"><div id=\"NDPrototype295\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\">webappos.desktop.show_user_menu = <span class=\"SHKeyword\">function</span> (</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PName first last\">around_id</td></tr></table></td><td class=\"PAfterParameters\">)</td></tr></table></div><div class=\"TTSummary\">Shows (or hides, if shown) the user menu containing the &quot;Sign out&quot; button.</div></div>",296:"<div class=\"NDToolTip TFunction LJavaScript\"><div id=\"NDPrototype296\" class=\"NDPrototype NoParameterForm\">webappos.close_current_project = <span class=\"SHKeyword\">function</span> ()</div><div class=\"TTSummary\">Closes the current project, but keeps the user signed in.</div></div>",297:"<div class=\"NDToolTip TFunction LJavaScript\"><div id=\"NDPrototype297\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\">window.webappos.set_project_id = <span class=\"SHKeyword\">function</span> (</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PName first last\">new_project_id</td></tr></table></td><td class=\"PAfterParameters\">)</td></tr></table></div><div class=\"TTSummary\">Updates/changes the current project_id.&nbsp; This function can be redefined (e.g., by EnvironmentEngine) to changes the displayed project name as well.</div></div>",182:"<div class=\"NDToolTip TFunction LJavaScript\"><div id=\"NDPrototype182\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\">webappos.request_scopes = async <span class=\"SHKeyword\">function</span> (</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PName first last\">driver_name,</td></tr><tr><td class=\"PName first last\">scopes</td></tr></table></td><td class=\"PAfterParameters\">)</td></tr></table></div><div class=\"TTSummary\">Authenticates the user to use one or more particular scopes via the given scopes driver.</div></div>",300:"<div class=\"NDToolTip TFunction LJavaScript\"><div id=\"NDPrototype300\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\">webappos.get_scopes_driver = <span class=\"SHKeyword\">function</span> (</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PName first last\">driver_name</td></tr></table></td><td class=\"PAfterParameters\">)</td></tr></table></div><div class=\"TTSummary\">Returns the previously loaded scopes driver.&nbsp; Can be useful for scopes drivers themselves.</div></div>",301:"<div class=\"NDToolTip TFunction LJavaScript\"><div id=\"NDPrototype301\" class=\"NDPrototype NoParameterForm\">window.webappos.sign_out = async <span class=\"SHKeyword\">function</span> ()</div><div class=\"TTSummary\">Calls revoke_serverless_access() for all loaded scopes drivers, including &quot;webappos_scopes&quot;, if it was loaded (thus, releasing the webAppOS &quot;login&quot; scope and redirecting to the login page).&nbsp; The sign_out function DOES NOT release server-side scope tokens. This is done intentionally: tokens remain stored at the server side for future access (e.g., for re-mounting cloud drives on the next logon automatically).&nbsp; An exception is ws_token from the webAppOS &quot;login&quot; scope - it is revoked from the server as well.</div></div>",303:"<div class=\"NDToolTip TFunction LJavaScript\"><div id=\"NDPrototype303\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\">webappos.js_util.wait = async <span class=\"SHKeyword\">function</span> (</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PName first last\">ms</td></tr></table></td><td class=\"PAfterParameters\">)</td></tr></table></div><div class=\"TTSummary\">Waits the given mount of milliseconds.</div></div>",304:"<div class=\"NDToolTip TFunction LJavaScript\"><div id=\"NDPrototype304\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\">webappos.js_util.load_script = async <span class=\"SHKeyword\">function</span> (</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PName first last\">url</td></tr></table></td><td class=\"PAfterParameters\">)</td></tr></table></div><div class=\"TTSummary\">Loads the given script (asynchronously)</div></div>",305:"<div class=\"NDToolTip TFunction LJavaScript\"><div id=\"NDPrototype305\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\">webappos.js_util.exec_script = async <span class=\"SHKeyword\">function</span> (</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PName first last\">url</td></tr></table></td><td class=\"PAfterParameters\">)</td></tr></table></div><div class=\"TTSummary\">Loads and executes the given script.</div></div>",306:"<div class=\"NDToolTip TFunction LJavaScript\"><div id=\"NDPrototype306\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\">webappos.js_util.show_failure = <span class=\"SHKeyword\">function</span> (</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PName first last\">message</td></tr></table></td><td class=\"PAfterParameters\">)</td></tr></table></div><div class=\"TTSummary\">Displays a failure error box.</div></div>",307:"<div class=\"NDToolTip TFunction LJavaScript\"><div id=\"NDPrototype307\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\">webappos.js_util.find_element_by_class_name = <span class=\"SHKeyword\">function</span> (</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PName first last\">className,</td></tr><tr><td class=\"PName first last\">htmlSubStr</td></tr></table></td><td class=\"PAfterParameters\">)</td></tr></table></div><div class=\"TTSummary\">Returns the first HTML element having the given class and the given substring within element\'s innerHTML.</div></div>",308:"<div class=\"NDToolTip TFunction LJavaScript\"><div id=\"NDPrototype308\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\">webappos.js_util.await_condition = async <span class=\"SHKeyword\">function</span> (</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PName first last\">fCondition</td></tr></table></td><td class=\"PAfterParameters\">)</td></tr></table></div><div class=\"TTSummary\">Timeouts until the given condition function returns true.</div></div>",309:"<div class=\"NDToolTip TFunction LJavaScript\"><div id=\"NDPrototype309\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\">webappos.js_util.fire_event = <span class=\"SHKeyword\">function</span> (</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PName first last\">element,</td></tr><tr><td class=\"PName first last\">event_type</td></tr></table></td><td class=\"PAfterParameters\">)</td></tr></table></div><div class=\"TTSummary\">Emits the given event on the given element.</div></div>",310:"<div class=\"NDToolTip TFunction LJavaScript\"><div id=\"NDPrototype310\" class=\"NDPrototype NoParameterForm\">webappos.js_util.print_stack_trace = <span class=\"SHKeyword\">function</span> ()</div><div class=\"TTSummary\">Prints the current stack trace via console.log</div></div>",311:"<div class=\"NDToolTip TFunction LJavaScript\"><div id=\"NDPrototype311\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\">webappos.js_util.clone_object = <span class=\"SHKeyword\">function</span> (</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PName first last\">obj</td></tr></table></td><td class=\"PAfterParameters\">)</td></tr></table></div><div class=\"TTSummary\">Calls the object constructor to create a clone of the given object and copies own properties (non-recursively).</div></div>",312:"<div class=\"NDToolTip TFunction LJavaScript\"><div id=\"NDPrototype312\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\">webappos.js_util.clone_object_properties = <span class=\"SHKeyword\">function</span> (</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PName first last\">obj</td></tr></table></td><td class=\"PAfterParameters\">)</td></tr></table></div><div class=\"TTSummary\">Creates a new object {} and copies own properties of the given object (non-recursively).</div></div>",313:"<div class=\"NDToolTip TFunction LJavaScript\"><div id=\"NDPrototype313\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\">webappos.js_util.slice = <span class=\"SHKeyword\">function</span> (</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PName first last\">arr,</td></tr><tr><td class=\"PName first last\">i,</td></tr><tr><td class=\"PName first last\">j</td></tr></table></td><td class=\"PAfterParameters\">)</td></tr></table></div><div class=\"TTSummary\">Returns a sub-array of the given array. Correctly works with Float64Arrays.</div></div>",314:"<div class=\"NDToolTip TFunction LJavaScript\"><div class=\"TTSummary\">Implementing the inheritance relation via JavaScript prototypes.</div></div>",315:"<div class=\"NDToolTip TFunction LJavaScript\"><div id=\"NDPrototype315\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\">webappos.js_util.is_true_object = <span class=\"SHKeyword\">function</span> (</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PName first last\">item</td></tr></table></td><td class=\"PAfterParameters\">)</td></tr></table></div><div class=\"TTSummary\">Checks whether the given JS variable is of type &quot;object&quot; AND not null AND not array.</div></div>",316:"<div class=\"NDToolTip TFunction LJavaScript\"><div id=\"NDPrototype316\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\">webappos.js_util.is_object = <span class=\"SHKeyword\">function</span> (</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PName first last\">item</td></tr></table></td><td class=\"PAfterParameters\">)</td></tr></table></div><div class=\"TTSummary\">Checks whether the given JS variable is an object or an array.</div></div>",317:"<div class=\"NDToolTip TFunction LJavaScript\"><div id=\"NDPrototype317\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\">webappos.js_util.is_array = <span class=\"SHKeyword\">function</span> (</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PName first last\">obj</td></tr></table></td><td class=\"PAfterParameters\">)</td></tr></table></div><div class=\"TTSummary\">Checks whether the given JS variable is an array.</div></div>",318:"<div class=\"NDToolTip TFunction LJavaScript\"><div id=\"NDPrototype318\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\">webappos.js_util.is_function = <span class=\"SHKeyword\">function</span> (</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PName first last\">functionToCheck</td></tr></table></td><td class=\"PAfterParameters\">)</td></tr></table></div><div class=\"TTSummary\">Checks whether the given JS variable is a JS function.</div></div>",319:"<div class=\"NDToolTip TFunction LJavaScript\"><div id=\"NDPrototype319\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\">webappos.js_util.capitalize_first_letter = <span class=\"SHKeyword\">function</span> (</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PName first last\">string</td></tr></table></td><td class=\"PAfterParameters\">)</td></tr></table></div><div class=\"TTSummary\">Given a string, returns the same string with the first letter capitalized.</div></div>",320:"<div class=\"NDToolTip TFunction LJavaScript\"><div id=\"NDPrototype320\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\">webappos.js_util.starts_with = <span class=\"SHKeyword\">function</span> (</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PName first last\">s,</td></tr><tr><td class=\"PName first last\">prefix</td></tr></table></td><td class=\"PAfterParameters\">)</td></tr></table></div><div class=\"TTSummary\">Checks whether the given string s starts with the given prefix.</div></div>",321:"<div class=\"NDToolTip TFunction LJavaScript\"><div id=\"NDPrototype321\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\">webappos.js_util.find_element_by_tag_name = <span class=\"SHKeyword\">function</span> (</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PName first last\">tagName,</td></tr><tr><td class=\"PName first last\">htmlSubStr</td></tr></table></td><td class=\"PAfterParameters\">)</td></tr></table></div><div class=\"TTSummary\">Returns the first HTML element with the given tag name and the given substring within element\'s innerHTML.</div></div>",322:"<div class=\"NDToolTip TFunction LJavaScript\"><div id=\"NDPrototype322\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\">webappos.js_util.initialize_file_input = <span class=\"SHKeyword\">function</span>(</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PName first last\">inputElement,</td></tr><tr><td class=\"PName first last\">previouslyChosenFiles</td></tr></table></td><td class=\"PAfterParameters\">)</td></tr></table></div><div class=\"TTSummary\">Initializes the given &lt;input type=&quot;file&quot;&gt; element for uploading files.&nbsp; Use webappos.js_util.upload_file_input to upload the files.</div></div>",323:"<div class=\"NDToolTip TFunction LJavaScript\"><div id=\"NDPrototype323\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\">webappos.js_util.upload_file_input = <span class=\"SHKeyword\">function</span>(</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PName first last\">inputElement,</td></tr><tr><td class=\"PName first last\">pathPrefix</td></tr></table></td><td class=\"PAfterParameters\">)</td></tr></table></div><div class=\"TTSummary\">Uploads the files selected by the user in the &lt;input type=&quot;file&quot;&gt; element.&nbsp; Can be called even when the input has not been initialized using webappos.js_util.initialize_file_input.</div></div>",324:"<div class=\"NDToolTip TFunction LJavaScript\"><div id=\"NDPrototype324\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\">webappos.js_util.show_please_wait = <span class=\"SHKeyword\">function</span> (</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PName first last\">msg</td></tr></table></td><td class=\"PAfterParameters\">)</td></tr></table></div><div class=\"TTSummary\">Shows a modal &quot;Please, wait&quot; window with the given message.</div></div>",325:"<div class=\"NDToolTip TFunction LJavaScript\"><div id=\"NDPrototype325\" class=\"NDPrototype NoParameterForm\">webappos.js_util.hide_please_wait = <span class=\"SHKeyword\">function</span> ()</div><div class=\"TTSummary\">Hides the &quot;Please, wait&quot; window shown earlier</div></div>",327:"<div class=\"NDToolTip TVariable LJavaScript\"><div id=\"NDPrototype327\" class=\"NDPrototype NoParameterForm\">webappos.app_url_name</div><div class=\"TTSummary\">Stores the current application URL name</div></div>",328:"<div class=\"NDToolTip TVariable LJavaScript\"><div id=\"NDPrototype328\" class=\"NDPrototype NoParameterForm\">webappos.project_id</div><div class=\"TTSummary\">Stores the current project_id (or null).&nbsp; Initialized during requrest_scopes(&quot;webappos_scopes&quot;, &quot;project_id&quot;).</div></div>",330:"<div class=\"NDToolTip TFunction LJavaScript\"><div id=\"NDPrototype330\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\">webappos.js_util.get_query_value = <span class=\"SHKeyword\">function</span> (</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PName first last\">key</td></tr></table></td><td class=\"PAfterParameters\">)</td></tr></table></div><div class=\"TTSummary\">Returns the argument value from the query string</div></div>",331:"<div class=\"NDToolTip TFunction LJavaScript\"><div id=\"NDPrototype331\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\">webappos.js_util.update_query_value = <span class=\"SHKeyword\">function</span> (</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PName first last\">key,</td></tr><tr><td class=\"PName first last\">value</td></tr></table></td><td class=\"PAfterParameters\">)</td></tr></table></div><div class=\"TTSummary\">Updates (sets) the given value for the given key in the current query string.</div></div>",332:"<div class=\"NDToolTip TFunction LJavaScript\"><div id=\"NDPrototype332\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\">webappos.js_util.get_and_remove_query_value = <span class=\"SHKeyword\">function</span> (</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PName first last\">key</td></tr></table></td><td class=\"PAfterParameters\">)</td></tr></table></div><div class=\"TTSummary\">Given the key, removes the key=value fragment from the query string and returns the deleted value.</div></div>",333:"<div class=\"NDToolTip TFunction LJavaScript\"><div id=\"NDPrototype333\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\">webappos.js_util.get_top_level_query_value = <span class=\"SHKeyword\">function</span> (</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PName first last\">key</td></tr></table></td><td class=\"PAfterParameters\">)</td></tr></table></div><div class=\"TTSummary\">Returns the argument value from the query string of the top-level frame.</div></div>",335:"<div class=\"NDToolTip TFunction LJavaScript\"><div id=\"NDPrototype335\" class=\"NDPrototype NoParameterForm\">webappos.init_web_memory = async <span class=\"SHKeyword\">function</span> ()</div><div class=\"TTSummary\">Performs the initial synchronization of web memory and keeps on synchronizing.</div></div>",336:"<div class=\"NDToolTip TVariable LJavaScript\"><div id=\"NDPrototype336\" class=\"NDPrototype NoParameterForm\">window.webmem</div><div class=\"TTSummary\">Provides access to &quot;web memory&quot;. This object becomes available only when web memory has been initialized by calling webappos.init_web_memory. The object will be the same for the iframe that initialized web memory and all descendant iframes that will include webappos.js.</div></div>",337:"<div class=\"NDToolTip TFunction LJavaScript\"><div class=\"TTSummary\">Attaches the given command or event object to the submitter object to execute the given command or handle the given event.</div></div>",338:"<div class=\"NDToolTip TFunction LJavaScript\"><div class=\"TTSummary\">Executes the given web call asynchronously via the current webAppOS web socket.&nbsp; Client-side webcalls are executed right away.</div></div>"});